--- 
default:  
  image:
    name: registry.gitlab.com/alen.kansakar/gitlab-runnersetup/myrunner
    entrypoint:
    - "/usr/bin/env"


variables:
  PLAN: plan.tfplan
  JSON_PLAN_FILE: tfplan.json

stages:
  - dockerbuild
  - plan
  - test
  - apply

include:
- local: '.gitlab-ci-includes.yml'

.dockerbuild:
  stage: dockerbuild
  image:
    name: docker:19.03.12
  tags:
    - dind
  script:
    - cd ${LOCATIONNAME}
    - docker build .
    - cd ..
  rules:
    - changes:
        - ${LOCATIONNAME}/* 


.mainplan:
  stage: plan
  tags:
    - dind
  script:
    - echo "Stage Plan"
    - cd "${LOCATIONNAME}"
    - pwd
    - /usr/local/bin/terraform init
    - /usr/local/bin/terraform plan
  # rules:
  #   - if: '$CI_MERGE_REQUEST_ID'
  #     changes:
  #       - ${LOCATIONNAME}/* 
  #     when: on_success

.maintest:
  stage: test
  tags:
    - dind
  script:
    - echo "Stage test"
    - cd "${LOCATIONNAME}"
    - |
      if grep -iq resource ./*; then 
        echo "Direct resource created"
        exit 1
      fi
    - pwd
    - /usr/local/bin/terraform init
    - /usr/local/bin/terraform plan

.mainapply:
  stage: apply
  tags:
    - dind
  script:
    - echo "TF apply --autoapprove"
